----------------------------------------------------------
  Cray Standard C V>=3.0 compiler listing
  Produced by mkcclisting.c V2.0 (written by PJ 22.5.1995)
----------------------------------------------------------
     1  /*
     2   * This file is part of tela the Tensor Language.
     3   * Copyright (c) 1994-1995 Pekka Janhunen
     4   */
     5  
     6  /*
     7   * tbinop.C - 'template' for a binary operator, included separately for +,-,*,/
     8   */
     9  
    10  static void OPFNAME(Treal y[], const Treal x[], const Treal a, const int N) {
    11  	for (int i=0; i<N; i++) y[i] = OP(x[i],a);
******    Loop starting at line 11 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 11 was unrolled 2 times.
******    Loop starting at line 11 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 11 was unrolled 2 times.
******    Loop starting at line 11 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 11 was unrolled 2 times.
******    Loop starting at line 11 was vectorized.  A "ivdep" directive was specified.
    12  }
    13  
    14  static void OPFNAME(Treal y[], const Treal a, const Treal x[], const int N) {
    15  	for (int i=0; i<N; i++) y[i] = OP(a,x[i]);
******    Loop starting at line 15 was bottom loaded.
******    Loop starting at line 15 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 15 was unrolled 2 times.
******    Loop starting at line 15 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 15 was unrolled 2 times.
******    Loop starting at line 15 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 15 was unrolled 2 times.
******    Loop starting at line 15 was vectorized.  A "ivdep" directive was specified.
    16  }
    17  
    18  static void OPFNAME(Treal z[], const Treal x[], const Treal y[], const int N) {
    19  	for (int i=0; i<N; i++) z[i] = OP(x[i],y[i]);
******    Loop starting at line 19 was bottom loaded.
******    Loop starting at line 19 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 19 was unrolled 2 times.
******    Loop starting at line 19 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 19 was unrolled 2 times.
******    Loop starting at line 19 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 19 was unrolled 2 times.
******    Loop starting at line 19 was vectorized.  A "ivdep" directive was specified.
    20  }
    21  
    22  /*
    23    Mflops recording policy:
    24    real,real is one op,
    25    real,complex is two ops (correct for both + and *)
    26    complex,complex is four ops (average of 2 (+) and 6 (*))
    27  */
    28  
    29  void OPFNAME(Tobject& c, const Tobject& a, const Tobject& b) {
    30  	int i,N;
    31  	Tint I; Treal X; Tcomplex Z;
    32  	switch (pair(a.kind(),b.kind())) {
    33  	case pair(Kint,Kint):
    34  		c = OP(a.IntValue(),b.IntValue());
    35  		global::nops++;
    36  		break;
    37  	case pair(Kint,Kreal):
    38  		c = OP(Treal(a.IntValue()),b.RealValue());
    39  		global::nops++;
    40  		break;
    41  	case pair(Kint,Kcomplex):
    42  		c = OP(Tcomplex(a.IntValue()),b.ComplexValue());
    43  		global::nops+= 2;
    44  		break;
    45  	case pair(Kint,KIntArray):
    46  		{
    47  			I = a.IntValue();
    48  			N = b.length();
    49  			c.copydimsIntArray(b);
    50  			Tint * const cp=c.IntPtr(), * const bp=b.IntPtr();
    51  			for (i=0; i<N; i++) cp[i] = OP(I,bp[i]);
******    Loop starting at line 51 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 51 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 51 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 51 was vectorized.  A "ivdep" directive was specified.
    52  			global::nops+= N;
    53  		}
    54  		break;
    55  	case pair(Kint,KRealArray):
    56  		{
    57  			X = Treal(a.IntValue());
    58  			N = b.length();
    59  			c.copydimsRealArray(b);
    60  			Treal * const cp=c.RealPtr(), * const bp=b.RealPtr();
    61  			OPFNAME(cp,X,bp,N);
    62  			global::nops+= N;
    63  		}
    64  		break;
    65  	case pair(Kint,KComplexArray):
    66  		{
    67  			Z = Tcomplex(Treal(a.IntValue()),0.0);
    68  			N = b.length();
    69  			c.copydimsComplexArray(b);
    70  			Tcomplex * const cp=c.ComplexPtr(), * const bp=b.ComplexPtr();
    71  			for (i=0; i<N; i++) cp[i] = OP(Z,bp[i]);
******    Loop starting at line 71 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 71 was not vectorized.  It contains a reference to a whole structure at line 71.
******    Loop starting at line 71 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 71 was not vectorized.  It contains a reference to a whole structure at line 71.
******    Loop starting at line 71 was bottom loaded.
******    Loop starting at line 71 was not vectorized.  It contains a reference to a whole structure at line 71.
******    Loop starting at line 71 was bottom loaded.
******    Loop starting at line 71 was not vectorized.  It contains a reference to a whole structure at line 71.
    72  			global::nops+= N*2;
    73  		}
    74  		break;
    75  	case pair(Kreal,Kint):
    76  		c = OP(a.RealValue(),Treal(b.IntValue()));
    77  		global::nops++;
    78  		break;
    79  	case pair(Kreal,Kreal):
    80  		c = OP(a.RealValue(),b.RealValue());
    81  		global::nops++;
    82  		break;
    83  	case pair(Kreal,Kcomplex):
    84  		c = OP(Tcomplex(a.RealValue()),b.ComplexValue());
    85  		global::nops+= 2;
    86  		break;
    87  	case pair(Kreal,KIntArray):
    88  		N = b.length();
    89  		X = a.RealValue();
    90  		if (&c == &b) {
    91  			Tobject c1;
    92  			c1.copydimsRealArray(b);
    93  			Treal * const c1p=c1.RealPtr(); Tint * const bp=b.IntPtr();
    94  			for (i=0; i<N; i++) c1p[i] = OP(X,bp[i]);
******    Loop starting at line 94 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 94 was unrolled 2 times.
******    Loop starting at line 94 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 94 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 94 was vectorized.  A "ivdep" directive was specified.
    95  			//c = c1;
    96  			c.bitwiseMoveFrom(c1);
    97  		} else {
    98  			c.copydimsRealArray(b);	// make c a real array of the same dims as b
    99  			Treal * const cp=c.RealPtr(); Tint * const bp=b.IntPtr();
   100  			for (i=0; i<N; i++) cp[i] = OP(X,bp[i]);
******    Loop starting at line 100 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 100 was unrolled 2 times.
******    Loop starting at line 100 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 100 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 100 was vectorized.  A "ivdep" directive was specified.
   101  		}
   102  		global::nops+= N;
   103  		break;
   104  	case pair(Kreal,KRealArray):
   105  		{
   106  			N = b.length();
   107  			X = a.RealValue();
   108  			c.copydimsRealArray(b);
   109  			Treal * const cp=c.RealPtr(), * const bp=b.RealPtr();
   110  			OPFNAME(cp,X,bp,N);
   111  			global::nops+= N;
   112  		}
   113  		break;
   114  	case pair(Kreal,KComplexArray):
   115  		{
   116  			Z = a.RealValue();
   117  			N = b.length();
   118  			c.copydimsComplexArray(b);
   119  			Tcomplex * const cp=c.ComplexPtr(), * const bp=b.ComplexPtr();
   120  			for (i=0; i<N; i++) cp[i] = OP(Z,bp[i]);
******    Loop starting at line 120 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 120 was not vectorized.  It contains a reference to a whole structure at line 120.
******    Loop starting at line 120 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 120 was not vectorized.  It contains a reference to a whole structure at line 120.
******    Loop starting at line 120 was bottom loaded.
******    Loop starting at line 120 was not vectorized.  It contains a reference to a whole structure at line 120.
******    Loop starting at line 120 was bottom loaded.
******    Loop starting at line 120 was not vectorized.  It contains a reference to a whole structure at line 120.
   121  			global::nops+= N*2;
   122  		}
   123  		break;
   124  	case pair(Kcomplex,Kint):
   125  		c = OP(a.ComplexValue(),Tcomplex(b.IntValue()));
   126  		global::nops+= 2;
   127  		break;
   128  	case pair(Kcomplex,Kreal):
   129  		c = OP(a.ComplexValue(),Tcomplex(b.RealValue()));
   130  		global::nops+= 2;
   131  		break;
   132  	case pair(Kcomplex,Kcomplex):
   133  		c = OP(a.ComplexValue(),b.ComplexValue());
   134  		global::nops+= 4;
   135  		break;
   136  	case pair(Kcomplex,KIntArray):
   137  		N = b.length();
   138  		Z = a.ComplexValue();
   139  		if (&c == &b) {
   140  			Tobject c1;
   141  			c1.copydimsComplexArray(b);
   142  			Tcomplex * const c1p=c1.ComplexPtr(); Tint * const bp=b.IntPtr();
   143  			for (i=0; i<N; i++) c1p[i] = OP(Z,bp[i]);
******    Loop starting at line 143 was not vectorized.  It contains a function call to "modulus__F7complexi".
******    Loop starting at line 143 was not vectorized.  It contains a reference to a whole structure at line 143.
******    Loop starting at line 143 was bottom loaded.
******    Loop starting at line 143 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 143 was not vectorized.  It contains a reference to a whole structure at line 143.
******    Loop starting at line 143 was bottom loaded.
******    Loop starting at line 143 was not vectorized.  It contains a reference to a whole structure at line 143.
******    Loop starting at line 143 was bottom loaded.
******    Loop starting at line 143 was not vectorized.  It contains a reference to a whole structure at line 143.
   144  			c.bitwiseMoveFrom(c1);
   145  		} else {
   146  			c.copydimsComplexArray(b);
   147  			Tint * const bp=b.IntPtr();
   148  			Tcomplex *cp=c.ComplexPtr();
   149  			for (i=0; i<N; i++) cp[i] = OP(Z,bp[i]);
******    Loop starting at line 149 was not vectorized.  It contains a function call to "modulus__F7complexi".
******    Loop starting at line 149 was not vectorized.  It contains a reference to a whole structure at line 149.
******    Loop starting at line 149 was bottom loaded.
******    Loop starting at line 149 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 149 was not vectorized.  It contains a reference to a whole structure at line 149.
******    Loop starting at line 149 was bottom loaded.
******    Loop starting at line 149 was not vectorized.  It contains a reference to a whole structure at line 149.
******    Loop starting at line 149 was bottom loaded.
******    Loop starting at line 149 was not vectorized.  It contains a reference to a whole structure at line 149.
   150  		}
   151  		global::nops+= N*2;
   152  		break;
   153  	case pair(Kcomplex,KRealArray):
   154  		N = b.length();
   155  		Z = a.ComplexValue();
   156  		if (&c == &b) {
   157  			Tobject c1;
   158  			c1.copydimsComplexArray(b);
   159  			Tcomplex * const c1p=c1.ComplexPtr(); Treal * const bp=b.RealPtr();
   160  			for (i=0; i<N; i++) c1p[i] = OP(Z,bp[i]);
******    Loop starting at line 160 was not vectorized.  It contains a function call to "modulus__F7complexd".
******    Loop starting at line 160 was not vectorized.  It contains a reference to a whole structure at line 160.
******    Loop starting at line 160 was bottom loaded.
******    Loop starting at line 160 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 160 was not vectorized.  It contains a reference to a whole structure at line 160.
******    Loop starting at line 160 was bottom loaded.
******    Loop starting at line 160 was not vectorized.  It contains a reference to a whole structure at line 160.
******    Loop starting at line 160 was bottom loaded.
******    Loop starting at line 160 was not vectorized.  It contains a reference to a whole structure at line 160.
   161  			c.bitwiseMoveFrom(c1);
   162  		} else {
   163  			c.copydimsComplexArray(b);
   164  			Tcomplex * const cp=c.ComplexPtr(); Treal * const bp=b.RealPtr();
   165  			for (i=0; i<N; i++) cp[i] = OP(Z,bp[i]);
******    Loop starting at line 165 was not vectorized.  It contains a function call to "modulus__F7complexd".
******    Loop starting at line 165 was not vectorized.  It contains a reference to a whole structure at line 165.
******    Loop starting at line 165 was bottom loaded.
******    Loop starting at line 165 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 165 was not vectorized.  It contains a reference to a whole structure at line 165.
******    Loop starting at line 165 was bottom loaded.
******    Loop starting at line 165 was not vectorized.  It contains a reference to a whole structure at line 165.
******    Loop starting at line 165 was bottom loaded.
******    Loop starting at line 165 was not vectorized.  It contains a reference to a whole structure at line 165.
   166  		}
   167  		global::nops+= N*2;
   168  		break;
   169  	case pair(Kcomplex,KComplexArray):
   170  		{
   171  			N = b.length();
   172  			Z = a.ComplexValue();
   173  			c.copydimsComplexArray(b);
   174  			Tcomplex * const cp=c.ComplexPtr(), * const bp=b.ComplexPtr();
   175  			for (i=0; i<N; i++) cp[i] = OP(Z,bp[i]);
******    Loop starting at line 175 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 175 was not vectorized.  It contains a reference to a whole structure at line 175.
******    Loop starting at line 175 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 175 was not vectorized.  It contains a reference to a whole structure at line 175.
******    Loop starting at line 175 was bottom loaded.
******    Loop starting at line 175 was not vectorized.  It contains a reference to a whole structure at line 175.
******    Loop starting at line 175 was bottom loaded.
******    Loop starting at line 175 was not vectorized.  It contains a reference to a whole structure at line 175.
   176  			global::nops+= N*4;
   177  		}
   178  		break;
   179  	case pair(KIntArray,Kint):
   180  		{
   181  			I = b.IntValue();
   182  			N = a.length();
   183  			c.copydimsIntArray(a);
   184  			Tint * const cp=c.IntPtr(), * const ap=a.IntPtr();
   185  			for (i=0; i<N; i++) cp[i] = OP(ap[i],I);
******    Loop starting at line 185 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 185 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 185 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 185 was vectorized.  A "ivdep" directive was specified.
   186  			global::nops+= N;
   187  		}
   188  		break;
   189  	case pair(KIntArray,Kreal):
   190  		N = a.length();
   191  		X = b.RealValue();
   192  		if (&c == &a) {
   193  			Tobject c1;
   194  			c1.copydimsRealArray(a);
   195  			Treal * const c1p=c1.RealPtr(); Tint * const ap=a.IntPtr();
   196  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],X);
******    Loop starting at line 196 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 196 was unrolled 2 times.
******    Loop starting at line 196 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 196 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 196 was vectorized.  A "ivdep" directive was specified.
   197  			c.bitwiseMoveFrom(c1);
   198  		} else {
   199  			c.copydimsRealArray(a);
   200  			Treal * const cp=c.RealPtr(); Tint * const ap=a.IntPtr();
   201  			for (i=0; i<N; i++) cp[i] = OP(ap[i],X);
******    Loop starting at line 201 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 201 was unrolled 2 times.
******    Loop starting at line 201 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 201 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 201 was vectorized.  A "ivdep" directive was specified.
   202  		}
   203  		global::nops+= N;
   204  		break;
   205  	case pair(KIntArray,Kcomplex):
   206  		N = a.length();
   207  		Z = b.ComplexValue();
   208  		if (&c == &a) {
   209  			Tobject c1;
   210  			c1.copydimsComplexArray(a);
   211  			Tcomplex * const c1p=c1.ComplexPtr(); Tint * const ap=a.IntPtr();
   212  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Z);
******    Loop starting at line 212 was bottom loaded.
******    Loop starting at line 212 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 212 was not vectorized.  It contains a reference to a whole structure at line 212.
******    Loop starting at line 212 was bottom loaded.
******    Loop starting at line 212 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 212 was not vectorized.  It contains a reference to a whole structure at line 212.
******    Loop starting at line 212 was bottom loaded.
******    Loop starting at line 212 was not vectorized.  It contains a reference to a whole structure at line 212.
******    Loop starting at line 212 was bottom loaded.
******    Loop starting at line 212 was not vectorized.  It contains a reference to a whole structure at line 212.
   213  			c.bitwiseMoveFrom(c1);
   214  		} else {
   215  			c.copydimsComplexArray(a);
   216  			Tcomplex * const cp=c.ComplexPtr(); Tint * const ap=a.IntPtr();
   217  			for (i=0; i<N; i++) cp[i] = OP(ap[i],Z);
******    Loop starting at line 217 was bottom loaded.
******    Loop starting at line 217 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 217 was not vectorized.  It contains a reference to a whole structure at line 217.
******    Loop starting at line 217 was bottom loaded.
******    Loop starting at line 217 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 217 was not vectorized.  It contains a reference to a whole structure at line 217.
******    Loop starting at line 217 was bottom loaded.
******    Loop starting at line 217 was not vectorized.  It contains a reference to a whole structure at line 217.
******    Loop starting at line 217 was bottom loaded.
******    Loop starting at line 217 was not vectorized.  It contains a reference to a whole structure at line 217.
   218  		}
   219  		global::nops+= N*2;
   220  		break;
   221  	case pair(KIntArray,KIntArray):
   222  		{
   223  			N = a.length();
   224  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   225  			c.copydimsIntArray(a);
   226  			Tint * const cp=c.IntPtr(), * const ap=a.IntPtr(), * const bp=b.IntPtr();
   227  			for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 227 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 227 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 227 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 227 was vectorized.  A "ivdep" directive was specified.
   228  			global::nops+= N;
   229  		}
   230  		break;
   231  	case pair(KIntArray,KRealArray):
   232  		{
   233  			N = a.length();
   234  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   235  			Treal * const bp=b.RealPtr(); Tint * const ap=a.IntPtr();
   236  			if (&a == &c) {
   237  				Tobject c1;
   238  				c1.copydimsRealArray(b);
   239  				Treal * const c1p=c1.RealPtr();
   240  				for (i=0; i<N; i++) c1p[i] = OP(Treal(ap[i]),bp[i]);
******    Loop starting at line 240 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 240 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 240 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 240 was vectorized.  A "ivdep" directive was specified.
   241  				c.bitwiseMoveFrom(c1);
   242  			} else {
   243  				c.copydimsRealArray(b);
   244  				Treal * const cp=c.RealPtr();
   245  				for (i=0; i<N; i++) cp[i] = OP(Treal(ap[i]),bp[i]);
******    Loop starting at line 245 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 245 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 245 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 245 was vectorized.  A "ivdep" directive was specified.
   246  			}
   247  			global::nops+= N;
   248  		}
   249  		break;
   250  	case pair(KIntArray,KComplexArray):
   251  		{
   252  			N = a.length();
   253  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   254  			Tcomplex * const bp=b.ComplexPtr(); Tint * const ap=a.IntPtr();
   255  			if (&a == &c) {
   256  				Tobject c1;
   257  				c1.copydimsComplexArray(b);
   258  				Tcomplex * const c1p=c1.ComplexPtr();
   259  				for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 259 was bottom loaded.
******    Loop starting at line 259 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 259 was not vectorized.  It contains a reference to a whole structure at line 259.
******    Loop starting at line 259 was bottom loaded.
******    Loop starting at line 259 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 259 was not vectorized.  It contains a reference to a whole structure at line 259.
******    Loop starting at line 259 was bottom loaded.
******    Loop starting at line 259 was not vectorized.  It contains a reference to a whole structure at line 259.
******    Loop starting at line 259 was bottom loaded.
******    Loop starting at line 259 was not vectorized.  It contains a reference to a whole structure at line 259.
   260  				c.bitwiseMoveFrom(c1);
   261  			} else {
   262  				c.copydimsComplexArray(b);
   263  				Tcomplex * const cp=c.ComplexPtr();
   264  				for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 264 was bottom loaded.
******    Loop starting at line 264 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 264 was not vectorized.  It contains a reference to a whole structure at line 264.
******    Loop starting at line 264 was bottom loaded.
******    Loop starting at line 264 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 264 was not vectorized.  It contains a reference to a whole structure at line 264.
******    Loop starting at line 264 was bottom loaded.
******    Loop starting at line 264 was not vectorized.  It contains a reference to a whole structure at line 264.
******    Loop starting at line 264 was bottom loaded.
******    Loop starting at line 264 was not vectorized.  It contains a reference to a whole structure at line 264.
   265  			}
   266  			global::nops+= N*2;
   267  		}
   268  		break;
   269  	case pair(KRealArray,Kint):
   270  		{
   271  			X = Treal(b.IntValue());
   272  			N = a.length();
   273  			c.copydimsRealArray(a);
   274  			Treal * const cp=c.RealPtr(), * const ap=a.RealPtr();
   275  			OPFNAME(cp,ap,X,N);
   276  			global::nops+= N;
   277  		}
   278  		break;
   279  	case pair(KRealArray,Kreal):
   280  		{
   281  			N = a.length();
   282  			X = b.RealValue();
   283  			c.copydimsRealArray(a);
   284  			Treal * const cp=c.RealPtr(), * const ap=a.RealPtr();
   285  			OPFNAME(cp,ap,X,N);
   286  			global::nops+= N;
   287  		}
   288  		break;
   289  	case pair(KRealArray,Kcomplex):
   290  		N = a.length();
   291  		Z = b.ComplexValue();
   292  		if (&c == &a) {
   293  			Tobject c1;
   294  			c1.copydimsComplexArray(a);
   295  			Tcomplex * const c1p=c1.ComplexPtr(); Treal * const ap=a.RealPtr();
   296  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Z);
******    Loop starting at line 296 was bottom loaded.
******    Loop starting at line 296 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 296 was not vectorized.  It contains a reference to a whole structure at line 296.
******    Loop starting at line 296 was bottom loaded.
******    Loop starting at line 296 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 296 was not vectorized.  It contains a reference to a whole structure at line 296.
******    Loop starting at line 296 was bottom loaded.
******    Loop starting at line 296 was not vectorized.  It contains a reference to a whole structure at line 296.
******    Loop starting at line 296 was bottom loaded.
******    Loop starting at line 296 was not vectorized.  It contains a reference to a whole structure at line 296.
   297  			c.bitwiseMoveFrom(c1);
   298  		} else {
   299  			c.copydimsComplexArray(a);
   300  			Tcomplex * const cp=c.ComplexPtr(); Treal * const ap=a.RealPtr();
   301  			for (i=0; i<N; i++) cp[i] = OP(ap[i],Z);
******    Loop starting at line 301 was bottom loaded.
******    Loop starting at line 301 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 301 was not vectorized.  It contains a reference to a whole structure at line 301.
******    Loop starting at line 301 was bottom loaded.
******    Loop starting at line 301 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 301 was not vectorized.  It contains a reference to a whole structure at line 301.
******    Loop starting at line 301 was bottom loaded.
******    Loop starting at line 301 was not vectorized.  It contains a reference to a whole structure at line 301.
******    Loop starting at line 301 was bottom loaded.
******    Loop starting at line 301 was not vectorized.  It contains a reference to a whole structure at line 301.
   302  		}
   303  		global::nops+= N*2;
   304  		break;
   305  	case pair(KRealArray,KIntArray):
   306  		{
   307  			N = a.length();
   308  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   309  			Treal * const ap=a.RealPtr(); Tint * const bp=b.IntPtr();
   310  			if (&c == &b) {
   311  				Tobject c1;
   312  				c1.copydimsRealArray(a);
   313  				Treal * const c1p=c1.RealPtr();
   314  				for (i=0; i<N; i++) c1p[i] = OP(ap[i],Treal(bp[i]));
******    Loop starting at line 314 was bottom loaded.
******    Loop starting at line 314 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 314 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 314 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 314 was vectorized.  A "ivdep" directive was specified.
   315  				c.bitwiseMoveFrom(c1);
   316  			} else {
   317  				c.copydimsRealArray(a);
   318  				Treal * const cp=c.RealPtr();
   319  				for (i=0; i<N; i++) cp[i] = OP(ap[i],Treal(bp[i]));
******    Loop starting at line 319 was bottom loaded.
******    Loop starting at line 319 was not vectorized.  It contains a function call to "fmod".
******    Loop starting at line 319 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 319 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 319 was vectorized.  A "ivdep" directive was specified.
   320  			}
   321  			global::nops+= N;
   322  		}
   323  		break;
   324  	case pair(KRealArray,KRealArray):
   325  		{
   326  			N = a.length();
   327  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   328  			c.copydimsRealArray(a);
   329  			Treal * const cp=c.RealPtr(), * const ap=a.RealPtr(), * const bp=b.RealPtr();
   330  			OPFNAME(cp,ap,bp,N);
   331  			global::nops+= N;
   332  		}
   333  		break;
   334  	case pair(KRealArray,KComplexArray):
   335  		{
   336  			N = a.length();
   337  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   338  			Tcomplex * const bp=b.ComplexPtr(); Treal * const ap=a.RealPtr();
   339  			if (&c == &a) {
   340  				Tobject c1;
   341  				c1.copydimsComplexArray(b);
   342  				Tcomplex * const c1p=c1.ComplexPtr();
   343  				for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 343 was bottom loaded.
******    Loop starting at line 343 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 343 was not vectorized.  It contains a reference to a whole structure at line 343.
******    Loop starting at line 343 was bottom loaded.
******    Loop starting at line 343 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 343 was not vectorized.  It contains a reference to a whole structure at line 343.
******    Loop starting at line 343 was bottom loaded.
******    Loop starting at line 343 was not vectorized.  It contains a reference to a whole structure at line 343.
******    Loop starting at line 343 was bottom loaded.
******    Loop starting at line 343 was not vectorized.  It contains a reference to a whole structure at line 343.
   344  				c.bitwiseMoveFrom(c1);
   345  			} else {
   346  				c.copydimsComplexArray(b);
   347  				Tcomplex * const cp=c.ComplexPtr();
   348  				for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 348 was bottom loaded.
******    Loop starting at line 348 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 348 was not vectorized.  It contains a reference to a whole structure at line 348.
******    Loop starting at line 348 was bottom loaded.
******    Loop starting at line 348 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 348 was not vectorized.  It contains a reference to a whole structure at line 348.
******    Loop starting at line 348 was bottom loaded.
******    Loop starting at line 348 was not vectorized.  It contains a reference to a whole structure at line 348.
******    Loop starting at line 348 was bottom loaded.
******    Loop starting at line 348 was not vectorized.  It contains a reference to a whole structure at line 348.
   349  			}
   350  			global::nops+= N*2;
   351  		}
   352  		break;
   353  	case pair(KComplexArray,Kint):
   354  		{
   355  			N = a.length();
   356  			Z = Tcomplex(b.IntValue());
   357  			c.copydimsComplexArray(a);
   358  			Tcomplex * const cp=c.ComplexPtr(), * const ap=a.ComplexPtr();
   359  			for (i=0; i<N; i++) cp[i] = OP(ap[i],Z);
******    Loop starting at line 359 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 359 was not vectorized.  It contains a reference to a whole structure at line 359.
******    Loop starting at line 359 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 359 was not vectorized.  It contains a reference to a whole structure at line 359.
******    Loop starting at line 359 was bottom loaded.
******    Loop starting at line 359 was not vectorized.  It contains a reference to a whole structure at line 359.
******    Loop starting at line 359 was bottom loaded.
******    Loop starting at line 359 was not vectorized.  It contains a reference to a whole structure at line 359.
   360  			global::nops+= N*2;
   361  		}
   362  		break;
   363  	case pair(KComplexArray,Kreal):
   364  		{
   365  			N = a.length();
   366  			Z = Tcomplex(b.RealValue());
   367  			c.copydimsComplexArray(a);
   368  			Tcomplex * const cp=c.ComplexPtr(), * const ap=a.ComplexPtr();
   369  			for (i=0; i<N; i++) cp[i] = OP(ap[i],Z);
******    Loop starting at line 369 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 369 was not vectorized.  It contains a reference to a whole structure at line 369.
******    Loop starting at line 369 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 369 was not vectorized.  It contains a reference to a whole structure at line 369.
******    Loop starting at line 369 was bottom loaded.
******    Loop starting at line 369 was not vectorized.  It contains a reference to a whole structure at line 369.
******    Loop starting at line 369 was bottom loaded.
******    Loop starting at line 369 was not vectorized.  It contains a reference to a whole structure at line 369.
   370  			global::nops+= N*2;
   371  		}
   372  		break;
   373  	case pair(KComplexArray,Kcomplex):
   374  		{
   375  			N = a.length();
   376  			Z = b.ComplexValue();
   377  			c.copydimsComplexArray(a);
   378  			Tcomplex * const cp=c.ComplexPtr(), * const ap=a.ComplexPtr();
   379  			for (i=0; i<N; i++) cp[i] = OP(ap[i],Z);
******    Loop starting at line 379 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 379 was not vectorized.  It contains a reference to a whole structure at line 379.
******    Loop starting at line 379 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 379 was not vectorized.  It contains a reference to a whole structure at line 379.
******    Loop starting at line 379 was bottom loaded.
******    Loop starting at line 379 was not vectorized.  It contains a reference to a whole structure at line 379.
******    Loop starting at line 379 was bottom loaded.
******    Loop starting at line 379 was not vectorized.  It contains a reference to a whole structure at line 379.
   380  			global::nops+= N*4;
   381  		}
   382  		break;
   383  	case pair(KComplexArray,KIntArray):
   384  		{
   385  			N = a.length();
   386  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   387  			Tcomplex * const ap=a.ComplexPtr(); Tint * const bp=b.IntPtr();
   388  			if (&c == &b) {
   389  				Tobject c1;
   390  				c1.copydimsComplexArray(a);
   391  				Tcomplex * const c1p=c1.ComplexPtr();
   392  				for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 392 was not vectorized.  It contains a function call to "modulus__F7complexi".
******    Loop starting at line 392 was not vectorized.  It contains a reference to a whole structure at line 392.
******    Loop starting at line 392 was bottom loaded.
******    Loop starting at line 392 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 392 was not vectorized.  It contains a reference to a whole structure at line 392.
******    Loop starting at line 392 was bottom loaded.
******    Loop starting at line 392 was not vectorized.  It contains a reference to a whole structure at line 392.
******    Loop starting at line 392 was bottom loaded.
******    Loop starting at line 392 was not vectorized.  It contains a reference to a whole structure at line 392.
   393  				c.bitwiseMoveFrom(c1);
   394  			} else {
   395  				c.copydimsComplexArray(a);
   396  				Tcomplex * const cp=c.ComplexPtr();
   397  				for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 397 was not vectorized.  It contains a function call to "modulus__F7complexi".
******    Loop starting at line 397 was not vectorized.  It contains a reference to a whole structure at line 397.
******    Loop starting at line 397 was bottom loaded.
******    Loop starting at line 397 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 397 was not vectorized.  It contains a reference to a whole structure at line 397.
******    Loop starting at line 397 was bottom loaded.
******    Loop starting at line 397 was not vectorized.  It contains a reference to a whole structure at line 397.
******    Loop starting at line 397 was bottom loaded.
******    Loop starting at line 397 was not vectorized.  It contains a reference to a whole structure at line 397.
   398  			}
   399  			global::nops+= N*2;
   400  		}
   401  		break;
   402  	case pair(KComplexArray,KRealArray):
   403  		{
   404  			N = a.length();
   405  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   406  			Tcomplex * const ap=a.ComplexPtr(); Treal * const bp=b.RealPtr();
   407  			if (&c == &b) {
   408  				Tobject c1;
   409  				c1.copydimsComplexArray(a);
   410  				Tcomplex * const c1p=c1.ComplexPtr();
   411  				for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 411 was not vectorized.  It contains a function call to "modulus__F7complexd".
******    Loop starting at line 411 was not vectorized.  It contains a reference to a whole structure at line 411.
******    Loop starting at line 411 was bottom loaded.
******    Loop starting at line 411 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 411 was not vectorized.  It contains a reference to a whole structure at line 411.
******    Loop starting at line 411 was bottom loaded.
******    Loop starting at line 411 was not vectorized.  It contains a reference to a whole structure at line 411.
******    Loop starting at line 411 was bottom loaded.
******    Loop starting at line 411 was not vectorized.  It contains a reference to a whole structure at line 411.
   412  				c.bitwiseMoveFrom(c1);
   413  			} else {
   414  				c.copydimsComplexArray(a);
   415  				Tcomplex * const cp=c.ComplexPtr();
   416  				for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 416 was not vectorized.  It contains a function call to "modulus__F7complexd".
******    Loop starting at line 416 was not vectorized.  It contains a reference to a whole structure at line 416.
******    Loop starting at line 416 was bottom loaded.
******    Loop starting at line 416 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 416 was not vectorized.  It contains a reference to a whole structure at line 416.
******    Loop starting at line 416 was bottom loaded.
******    Loop starting at line 416 was not vectorized.  It contains a reference to a whole structure at line 416.
******    Loop starting at line 416 was bottom loaded.
******    Loop starting at line 416 was not vectorized.  It contains a reference to a whole structure at line 416.
   417  			}
   418  			global::nops+= N*2;
   419  		}
   420  		break;
   421  	case pair(KComplexArray,KComplexArray):
   422  		{
   423  			N = a.length();
   424  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   425  			/****
   426  			   Added &c==&a test 9.1.1995.
   427  			   OP x,x,y yielded error if x.iscompatible(y) was true but x.dims()!=y.dims().
   428  			   This was possible e.g. if x=rand(3) and y=rand(1,3).
   429  			   This should fix it here, but is the same bug lurking elsewhere?
   430  			   Think about this!!!
   431  			   *****/
   432  			if (&c == &a) {
   433  				Tobject c1;
   434  				c1.copydimsComplexArray(b);
   435  				Tcomplex * const cp=c1.ComplexPtr(), * const bp=b.ComplexPtr(), * const ap=a.ComplexPtr();
   436  				for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 436 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 436 was not vectorized.  It contains a reference to a whole structure at line 436.
******    Loop starting at line 436 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 436 was not vectorized.  It contains a reference to a whole structure at line 436.
******    Loop starting at line 436 was bottom loaded.
******    Loop starting at line 436 was not vectorized.  It contains a reference to a whole structure at line 436.
******    Loop starting at line 436 was bottom loaded.
******    Loop starting at line 436 was not vectorized.  It contains a reference to a whole structure at line 436.
   437  				c.bitwiseMoveFrom(c1);
   438  			} else {
   439  				c.copydimsComplexArray(b);
   440  				Tcomplex * const cp=c.ComplexPtr(), * const bp=b.ComplexPtr(), * const ap=a.ComplexPtr();
   441  				for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 441 was not vectorized.  It contains a function call to "modulus__F7complexT1".
******    Loop starting at line 441 was not vectorized.  It contains a reference to a whole structure at line 441.
******    Loop starting at line 441 was not vectorized.  It contains a function call to "__ml__F7complexT1".
******    Loop starting at line 441 was not vectorized.  It contains a reference to a whole structure at line 441.
******    Loop starting at line 441 was bottom loaded.
******    Loop starting at line 441 was not vectorized.  It contains a reference to a whole structure at line 441.
******    Loop starting at line 441 was bottom loaded.
******    Loop starting at line 441 was not vectorized.  It contains a reference to a whole structure at line 441.
   442  			}
   443  			global::nops+= N*4;
   444  		}
   445  		break;
   446  	default:
   447  		BinError(OPCHAR,a,b);
   448  		break;
   449  	}
   450  }
