----------------------------------------------------------
  Cray Standard C V>=3.0 compiler listing
  Produced by mkcclisting.c V2.0 (written by PJ 22.5.1995)
----------------------------------------------------------
     1  /*
     2   * This file is part of tela the Tensor Language.
     3   * Copyright (c) 1994-1995 Pekka Janhunen
     4   */
     5  
     6  /*
     7   * tcmpop.C - 'template' for a binary compare operator, included separately for >,<,>=,<=
     8   */
     9  
    10  void OPFNAME(Tobject& c, const Tobject& a, const Tobject& b) {
    11  	int i,N;
    12  	Tint I; Treal X;
    13  	switch (pair(a.kind(),b.kind())) {
    14  	case pair(Kint,Kint):
    15  		c = OP(a.IntValue(),b.IntValue());
    16  		global::nops++;
    17  		break;
    18  	case pair(Kint,Kreal):
    19  		c = OP(Treal(a.IntValue()),b.RealValue());
    20  		global::nops++;
    21  		break;
    22  	case pair(Kint,KIntArray):
    23  		{
    24  			I = a.IntValue();
    25  			N = b.length();
    26  			c.copydimsIntArray(b);
    27  			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
    28  			for (i=0; i<N; i++) cp[i] = OP(I,bp[i]);
******    Loop starting at line 28 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 28 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 28 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 28 was vectorized.  A "ivdep" directive was specified.
    29  			global::nops+= N;
    30  		}
    31  		break;
    32  	case pair(Kint,KRealArray):
    33  		{
    34  			Tobject c1;
    35  			N = b.length();
    36  			X = Treal(a.IntValue());
    37  			c1.copydimsIntArray(b);
    38  			Tint *c1p=c1.IntPtr(); Treal *bp=b.RealPtr();
    39  			for (i=0; i<N; i++) c1p[i] = OP(X,bp[i]);
******    Loop starting at line 39 was unrolled 2 times.
******    Loop starting at line 39 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 39 was unrolled 2 times.
******    Loop starting at line 39 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 39 was unrolled 2 times.
******    Loop starting at line 39 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 39 was unrolled 2 times.
******    Loop starting at line 39 was vectorized.  A "ivdep" directive was specified.
    40  			//c = c1;
    41  			c.bitwiseMoveFrom(c1);
    42  			global::nops+= N;
    43  		}
    44  		break;
    45  	case pair(Kreal,Kint):
    46  		c = OP(a.RealValue(),Treal(b.IntValue()));
    47  		global::nops++;
    48  		break;
    49  	case pair(Kreal,Kreal):
    50  		c = OP(a.RealValue(),b.RealValue());
    51  		global::nops++;
    52  		break;
    53  	case pair(Kreal,KIntArray):
    54  		{
    55  			X = a.RealValue();
    56  			N = b.length();
    57  			c.copydimsIntArray(b);	// make c an int array of the same dims as b
    58  			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
    59  			for (i=0; i<N; i++) cp[i] = OP(X,bp[i]);
******    Loop starting at line 59 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 59 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 59 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 59 was vectorized.  A "ivdep" directive was specified.
    60  			global::nops+= N;
    61  		}
    62  		break;
    63  	case pair(Kreal,KRealArray):
    64  		{
    65  			Tobject c1;
    66  			N = b.length();
    67  			X = a.RealValue();
    68  			c1.copydimsIntArray(b);
    69  			Tint *c1p=c1.IntPtr(); Treal *bp=b.RealPtr();
    70  			for (i=0; i<N; i++) c1p[i] = OP(X,bp[i]);
******    Loop starting at line 70 was unrolled 2 times.
******    Loop starting at line 70 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 70 was unrolled 2 times.
******    Loop starting at line 70 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 70 was unrolled 2 times.
******    Loop starting at line 70 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 70 was unrolled 2 times.
******    Loop starting at line 70 was vectorized.  A "ivdep" directive was specified.
    71  			//c = c1;
    72  			c.bitwiseMoveFrom(c1);
    73  			global::nops+= N;
    74  		}
    75  		break;
    76  	case pair(KIntArray,Kint):
    77  		{
    78  			N = a.length();
    79  			I = b.IntValue();
    80  			c.copydimsIntArray(a);
    81  			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
    82  			for (i=0; i<N; i++) cp[i] = OP(ap[i],I);
******    Loop starting at line 82 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 82 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 82 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 82 was vectorized.  A "ivdep" directive was specified.
    83  			global::nops+= N;
    84  		}
    85  		break;
    86  	case pair(KIntArray,Kreal):
    87  		{
    88  			N = a.length();
    89  			X = b.RealValue();
    90  			c.copydimsIntArray(a);
    91  			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
    92  			for (i=0; i<N; i++) cp[i] = OP(ap[i],X);
******    Loop starting at line 92 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 92 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 92 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 92 was vectorized.  A "ivdep" directive was specified.
    93  			global::nops+= N;
    94  		}
    95  		break;
    96  	case pair(KIntArray,KIntArray):
    97  		{
    98  			N = a.length();
    99  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   100  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   101  			c.copydimsIntArray(a);
   102  			Tint *cp=c.IntPtr(), *ap=a.IntPtr(), *bp=b.IntPtr();
   103  			for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 103 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 103 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 103 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 103 was vectorized.  A "ivdep" directive was specified.
   104  			global::nops+= N;
   105  		}
   106  		break;
   107  	case pair(KIntArray,KRealArray):
   108  		{
   109  			Tobject c1;
   110  			c1.copydimsIntArray(b);
   111  			N = a.length();
   112  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   113  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   114  			Tint *c1p=c1.IntPtr(), *ap=a.IntPtr(); Treal *bp=b.RealPtr();
   115  			for (i=0; i<N; i++) c1p[i] = OP(Treal(ap[i]),bp[i]);
******    Loop starting at line 115 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 115 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 115 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 115 was vectorized.  A "ivdep" directive was specified.
   116  			//c = c1;
   117  			c.bitwiseMoveFrom(c1);
   118  			global::nops+= N;
   119  		}
   120  		break;
   121  	case pair(KRealArray,Kint):
   122  		{
   123  			Tobject c1;
   124  			N = a.length();
   125  			X = Treal(b.IntValue());
   126  			c1.copydimsIntArray(a);
   127  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr();
   128  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],X);
******    Loop starting at line 128 was unrolled 2 times.
******    Loop starting at line 128 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 128 was unrolled 2 times.
******    Loop starting at line 128 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 128 was unrolled 2 times.
******    Loop starting at line 128 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 128 was unrolled 2 times.
******    Loop starting at line 128 was vectorized.  A "ivdep" directive was specified.
   129  			//c = c1;
   130  			c.bitwiseMoveFrom(c1);
   131  			global::nops+= N;
   132  		}
   133  		break;
   134  	case pair(KRealArray,Kreal):
   135  		{
   136  			Tobject c1;
   137  			N = a.length();
   138  			X = b.RealValue();
   139  			c1.copydimsIntArray(a);
   140  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr();
   141  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],X);
******    Loop starting at line 141 was unrolled 2 times.
******    Loop starting at line 141 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 141 was unrolled 2 times.
******    Loop starting at line 141 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 141 was unrolled 2 times.
******    Loop starting at line 141 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 141 was unrolled 2 times.
******    Loop starting at line 141 was vectorized.  A "ivdep" directive was specified.
   142  			//c = c1;
   143  			c.bitwiseMoveFrom(c1);
   144  			global::nops+= N;
   145  		}
   146  		break;
   147  	case pair(KRealArray,KIntArray):
   148  		{
   149  			Tobject c1;
   150  			c1.copydimsIntArray(a);
   151  			N = a.length();
   152  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   153  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   154  			Tint *c1p=c1.IntPtr(), *bp=b.IntPtr(); Treal *ap=a.RealPtr();
   155  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Treal(bp[i]));
******    Loop starting at line 155 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 155 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 155 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 155 was vectorized.  A "ivdep" directive was specified.
   156  			//c = c1;
   157  			c.bitwiseMoveFrom(c1);
   158  			global::nops+= N;
   159  		}
   160  		break;
   161  	case pair(KRealArray,KRealArray):
   162  		{
   163  			Tobject c1;
   164  			c1.copydimsIntArray(a);
   165  			N = a.length();
   166  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   167  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   168  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr(), *bp=b.RealPtr();
   169  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 169 was unrolled 2 times.
******    Loop starting at line 169 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 169 was unrolled 2 times.
******    Loop starting at line 169 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 169 was unrolled 2 times.
******    Loop starting at line 169 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 169 was unrolled 2 times.
******    Loop starting at line 169 was vectorized.  A "ivdep" directive was specified.
   170  			//c = c1;
   171  			c.bitwiseMoveFrom(c1);
   172  			global::nops+= N;
   173  		}
   174  		break;
   175  	default:
   176  		BinError(OPCHAR,a,b);
   177  		break;
   178  	}
   179  }
