----------------------------------------------------------
  Cray Standard C V>=3.0 compiler listing
  Produced by mkcclisting.c V2.0 (written by PJ 22.5.1995)
----------------------------------------------------------
     1  /*
     2   * This file is part of tela the Tensor Language.
     3   * Copyright (c) 1994-1995 Pekka Janhunen
     4   */
     5  
     6  /*
     7   * teqop.C - 'template' for an equality operator, included separately for ==, !=
     8   */
     9  
    10  void OPFNAME(Tobject& c, const Tobject& a, const Tobject& b) {
    11  	int i,N;
    12  	Tint I; Treal X; Tcomplex Z;
    13  	switch (pair(a.kind(),b.kind())) {
    14  	case pair(Kint,Kint):
    15  		c = OP(a.IntValue(),b.IntValue());
    16  		global::nops++;
    17  		break;
    18  	case pair(Kint,Kreal):
    19  		c = OP(Treal(a.IntValue()),b.RealValue());
    20  		global::nops++;
    21  		break;
    22  	case pair(Kint,Kcomplex):
    23  		c = OP(Tcomplex(a.IntValue()),b.ComplexValue());
    24  		global::nops++;
    25  		break;
    26  	case pair(Kint,KIntArray):
    27  		{
    28  			I = a.IntValue();
    29  			N = b.length();
    30  			c.copydimsIntArray(b);
    31  			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
    32  			for (i=0; i<N; i++) cp[i] = OP(I,bp[i]);
******    Loop starting at line 32 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 32 was vectorized.  A "ivdep" directive was specified.
    33  			global::nops+= N;
    34  		}
    35  		break;
    36  	case pair(Kint,KRealArray):
    37  		{
    38  			Tobject c1;
    39  			X = Treal(a.IntValue());
    40  			N = b.length();
    41  			c1.copydimsIntArray(b);
    42  			Tint *c1p=c1.IntPtr(); Treal *bp=b.RealPtr();
    43  			for (i=0; i<N; i++) c1p[i] = OP(X,bp[i]);
******    Loop starting at line 43 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 43 was vectorized.  A "ivdep" directive was specified.
    44  			//c = c1;
    45  			c.bitwiseMoveFrom(c1);
    46  			global::nops+= N;
    47  		}
    48  		break;
    49  	case pair(Kint,KComplexArray):
    50  		{
    51  			Tobject c1;
    52  			Z = Tcomplex(Treal(a.IntValue()),0.0);
    53  			N = b.length();
    54  			c1.copydimsIntArray(b);
    55  			Tint *c1p=c1.IntPtr(); Tcomplex *bp=b.ComplexPtr();
    56  			for (i=0; i<N; i++) c1p[i] = OP(Z,bp[i]);
******    Loop starting at line 56 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 56 was vectorized.  A "ivdep" directive was specified.
    57  			//c = c1;
    58  			c.bitwiseMoveFrom(c1);
    59  			global::nops+= N;
    60  		}
    61  		break;
    62  	case pair(Kreal,Kint):
    63  		c = OP(a.RealValue(),Treal(b.IntValue()));
    64  		global::nops++;
    65  		break;
    66  	case pair(Kreal,Kreal):
    67  		c = OP(a.RealValue(),b.RealValue());
    68  		global::nops++;
    69  		break;
    70  	case pair(Kreal,Kcomplex):
    71  		c = OP(Tcomplex(a.RealValue()),b.ComplexValue());
    72  		global::nops++;
    73  		break;
    74  	case pair(Kreal,KIntArray):
    75  		{
    76  			N = b.length();
    77  			X = a.RealValue();
    78  			c.copydimsIntArray(b);	// make c an int array of the same dims as b
    79  			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
    80  			for (i=0; i<N; i++) cp[i] = OP(X,bp[i]);
******    Loop starting at line 80 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 80 was vectorized.  A "ivdep" directive was specified.
    81  			global::nops+= N;
    82  		}
    83  		break;
    84  	case pair(Kreal,KRealArray):
    85  		{
    86  			Tobject c1;
    87  			N = b.length();
    88  			X = a.RealValue();
    89  			c1.copydimsIntArray(b);
    90  			Tint *c1p=c1.IntPtr(); Treal *bp=b.RealPtr();
    91  			for (i=0; i<N; i++) c1p[i] = OP(X,bp[i]);
******    Loop starting at line 91 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 91 was vectorized.  A "ivdep" directive was specified.
    92  			//c = c1;
    93  			c.bitwiseMoveFrom(c1);
    94  			global::nops+= N;
    95  		}
    96  		break;
    97  	case pair(Kreal,KComplexArray):
    98  		{
    99  			Tobject c1;
   100  			Z = a.RealValue();
   101  			N = b.length();
   102  			c1.copydimsIntArray(b);
   103  			Tint *c1p=c1.IntPtr(); Tcomplex *bp=b.ComplexPtr();
   104  			for (i=0; i<N; i++) c1p[i] = OP(Z,bp[i]);
******    Loop starting at line 104 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 104 was vectorized.  A "ivdep" directive was specified.
   105  			//c = c1;
   106  			c.bitwiseMoveFrom(c1);
   107  			global::nops+= N;
   108  		}
   109  		break;
   110  	case pair(Kcomplex,Kint):
   111  		c = OP(a.ComplexValue(),Tcomplex(b.IntValue()));
   112  		global::nops++;
   113  		break;
   114  	case pair(Kcomplex,Kreal):
   115  		c = OP(a.ComplexValue(),Tcomplex(b.RealValue()));
   116  		global::nops++;
   117  		break;
   118  	case pair(Kcomplex,Kcomplex):
   119  		c = OP(a.ComplexValue(),b.ComplexValue());
   120  		global::nops++;
   121  		break;
   122  	case pair(Kcomplex,KIntArray):
   123  		{
   124  			N = b.length();
   125  			Z = a.ComplexValue();
   126  			c.copydimsIntArray(b);
   127  			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
   128  			for (i=0; i<N; i++) cp[i] = OP(Z,bp[i]);
******    Loop starting at line 128 was bottom loaded.
******    Loop starting at line 128 was not vectorized.  It contains a reference to a whole structure at line 128.
******    Loop starting at line 128 was bottom loaded.
******    Loop starting at line 128 was not vectorized.  It contains a reference to a whole structure at line 128.
   129  			global::nops+= N;
   130  		}
   131  		break;
   132  	case pair(Kcomplex,KRealArray):
   133  		{
   134  			N = b.length();
   135  			Z = a.ComplexValue();
   136  			Tobject c1;
   137  			c1.copydimsIntArray(b);
   138  			Tint *c1p=c1.IntPtr(); Treal *bp=b.RealPtr();
   139  			for (i=0; i<N; i++) c1p[i] = OP(Z,bp[i]);
******    Loop starting at line 139 was bottom loaded.
******    Loop starting at line 139 was not vectorized.  It contains a reference to a whole structure at line 139.
******    Loop starting at line 139 was bottom loaded.
******    Loop starting at line 139 was not vectorized.  It contains a reference to a whole structure at line 139.
   140  			//c = c1;
   141  			c.bitwiseMoveFrom(c1);
   142  			global::nops+= N;
   143  		}
   144  		break;
   145  	case pair(Kcomplex,KComplexArray):
   146  		{
   147  			Tobject c1;
   148  			N = b.length();
   149  			Z = a.ComplexValue();
   150  			c1.copydimsIntArray(b);
   151  			Tint *c1p=c1.IntPtr(); Tcomplex *bp=b.ComplexPtr();
   152  			for (i=0; i<N; i++) c1p[i] = OP(Z,bp[i]);
******    Loop starting at line 152 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 152 was vectorized.  A "ivdep" directive was specified.
   153  			//c = c1;
   154  			c.bitwiseMoveFrom(c1);
   155  			global::nops+= N;
   156  		}
   157  		break;
   158  	case pair(KIntArray,Kint):
   159  		{
   160  			I = b.IntValue();
   161  			N = a.length();
   162  			c.copydimsIntArray(a);
   163  			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
   164  			for (i=0; i<N; i++) cp[i] = OP(ap[i],I);
******    Loop starting at line 164 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 164 was vectorized.  A "ivdep" directive was specified.
   165  			global::nops+= N;
   166  		}
   167  		break;
   168  	case pair(KIntArray,Kreal):
   169  		{
   170  			N = a.length();
   171  			X = b.RealValue();
   172  			c.copydimsIntArray(a);
   173  			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
   174  			for (i=0; i<N; i++) cp[i] = OP(ap[i],X);
******    Loop starting at line 174 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 174 was vectorized.  A "ivdep" directive was specified.
   175  			global::nops+= N;
   176  		}
   177  		break;
   178  	case pair(KIntArray,Kcomplex):
   179  		{
   180  			N = a.length();
   181  			Z = b.ComplexValue();
   182  			c.copydimsIntArray(a);
   183  			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
   184  			for (i=0; i<N; i++) cp[i] = OP(ap[i],Z);
******    Loop starting at line 184 was bottom loaded.
******    Loop starting at line 184 was not vectorized.  It contains a reference to a whole structure at line 184.
******    Loop starting at line 184 was bottom loaded.
******    Loop starting at line 184 was not vectorized.  It contains a reference to a whole structure at line 184.
   185  			global::nops+= N;
   186  		}
   187  		break;
   188  	case pair(KIntArray,KIntArray):
   189  		N = a.length();
   190  		if (N == b.length()) {
   191  			c.copydimsIntArray(a);
   192  			Tint *cp=c.IntPtr(), *ap=a.IntPtr(), *bp=b.IntPtr();
   193  			for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 193 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 193 was vectorized.  A "ivdep" directive was specified.
   194  			global::nops+= N;
   195  		} else c = OP(0,1);
   196  		break;
   197  	case pair(KIntArray,KRealArray):
   198  		N = a.length();
   199  		if (N == b.length()) {
   200  			Tobject c1;
   201  			c1.copydimsIntArray(b);
   202  			Tint *c1p=c1.IntPtr(); Treal *bp=b.RealPtr(); Tint *ap=a.IntPtr();
   203  			for (i=0; i<N; i++) c1p[i] = OP(Treal(ap[i]),bp[i]);
******    Loop starting at line 203 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 203 was vectorized.  A "ivdep" directive was specified.
   204  			//c = c1;
   205  			c.bitwiseMoveFrom(c1);
   206  			global::nops+= N;
   207  		} else c = OP(0,1);
   208  		break;
   209  	case pair(KIntArray,KComplexArray):
   210  		N = a.length();
   211  		if (N == b.length()) {
   212  			Tobject c1;
   213  			c1.copydimsIntArray(b);
   214  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   215  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   216  			Tint *c1p=c1.IntPtr(); Tcomplex *bp=b.ComplexPtr(); Tint *ap=a.IntPtr();
   217  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 217 was bottom loaded.
******    Loop starting at line 217 was not vectorized.  It contains a reference to a whole structure at line 217.
******    Loop starting at line 217 was bottom loaded.
******    Loop starting at line 217 was not vectorized.  It contains a reference to a whole structure at line 217.
   218  			//c = c1;
   219  			c.bitwiseMoveFrom(c1);
   220  			global::nops+= N;
   221  		} else c = OP(0,1);
   222  		break;
   223  	case pair(KRealArray,Kint):
   224  		{
   225  			N = a.length();
   226  			X = Treal(b.IntValue());
   227  			Tobject c1;
   228  			c1.copydimsIntArray(a);
   229  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr();
   230  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],X);
******    Loop starting at line 230 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 230 was vectorized.  A "ivdep" directive was specified.
   231  			//c = c1;
   232  			c.bitwiseMoveFrom(c1);
   233  			global::nops+= N;
   234  		}
   235  		break;
   236  	case pair(KRealArray,Kreal):
   237  		{
   238  			N = a.length();
   239  			X = b.RealValue();
   240  			Tobject c1;
   241  			c1.copydimsIntArray(a);
   242  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr();
   243  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],X);
******    Loop starting at line 243 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 243 was vectorized.  A "ivdep" directive was specified.
   244  			//c = c1;
   245  			c.bitwiseMoveFrom(c1);
   246  			global::nops+= N;
   247  		}
   248  		break;
   249  	case pair(KRealArray,Kcomplex):
   250  		{
   251  			N = a.length();
   252  			Z = b.ComplexValue();
   253  			Tobject c1;
   254  			c1.copydimsIntArray(a);
   255  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr();
   256  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Z);
******    Loop starting at line 256 was bottom loaded.
******    Loop starting at line 256 was not vectorized.  It contains a reference to a whole structure at line 256.
******    Loop starting at line 256 was bottom loaded.
******    Loop starting at line 256 was not vectorized.  It contains a reference to a whole structure at line 256.
   257  			//c = c1;
   258  			c.bitwiseMoveFrom(c1);
   259  			global::nops+= N;
   260  		}
   261  		break;
   262  	case pair(KRealArray,KIntArray):
   263  		N = a.length();
   264  		if (N == b.length()) {
   265  			Tobject c1;
   266  			c1.copydimsIntArray(a);
   267  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr(); Tint *bp=b.IntPtr();
   268  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Treal(bp[i]));
******    Loop starting at line 268 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 268 was vectorized.  A "ivdep" directive was specified.
   269  			//c = c1;
   270  			c.bitwiseMoveFrom(c1);
   271  			global::nops+= N;
   272  		} else c = OP(0,1);
   273  		break;
   274  	case pair(KRealArray,KRealArray):
   275  		N = a.length();
   276  		if (N == b.length()) {
   277  			Tobject c1;
   278  			c1.copydimsIntArray(a);
   279  			Tint *c1p=c1.IntPtr(); Treal *ap=a.RealPtr(), *bp=b.RealPtr();
   280  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 280 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 280 was vectorized.  A "ivdep" directive was specified.
   281  			//c = c1;
   282  			c.bitwiseMoveFrom(c1);
   283  			global::nops+= N;
   284  		} else c = OP(0,1);
   285  		break;
   286  	case pair(KRealArray,KComplexArray):
   287  		N = a.length();
   288  		if (N == b.length()) {
   289  			Tobject c1;
   290  			c1.copydimsIntArray(b);
   291  			Tint *c1p=c1.IntPtr(); Tcomplex *bp=b.ComplexPtr(); Treal *ap=a.RealPtr();
   292  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 292 was bottom loaded.
******    Loop starting at line 292 was not vectorized.  It contains a reference to a whole structure at line 292.
******    Loop starting at line 292 was bottom loaded.
******    Loop starting at line 292 was not vectorized.  It contains a reference to a whole structure at line 292.
   293  			//c = c1;
   294  			c.bitwiseMoveFrom(c1);
   295  			global::nops+= N;
   296  		} else c = OP(0,1);
   297  		break;
   298  	case pair(KComplexArray,Kint):
   299  		{
   300  			N = a.length();
   301  			Z = Tcomplex(b.IntValue());
   302  			Tobject c1;
   303  			c1.copydimsIntArray(a);
   304  			Tint *c1p=c1.IntPtr(); Tcomplex *ap=a.ComplexPtr();
   305  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Z);
******    Loop starting at line 305 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 305 was vectorized.  A "ivdep" directive was specified.
   306  			//c = c1;
   307  			c.bitwiseMoveFrom(c1);
   308  			global::nops+= N;
   309  		}
   310  		break;
   311  	case pair(KComplexArray,Kreal):
   312  		{
   313  			N = a.length();
   314  			Z = Tcomplex(b.RealValue());
   315  			Tobject c1;
   316  			c1.copydimsIntArray(a);
   317  			Tint *c1p=c1.IntPtr(); Tcomplex *ap=a.ComplexPtr();
   318  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Z);
******    Loop starting at line 318 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 318 was vectorized.  A "ivdep" directive was specified.
   319  			//c = c1;
   320  			c.bitwiseMoveFrom(c1);
   321  			global::nops+= N;
   322  		}
   323  		break;
   324  	case pair(KComplexArray,Kcomplex):
   325  		{
   326  			N = a.length();
   327  			Z = b.ComplexValue();
   328  			Tobject c1;
   329  			c1.copydimsIntArray(a);
   330  			Tint *c1p=c1.IntPtr(); Tcomplex *ap=a.ComplexPtr();
   331  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Z);
******    Loop starting at line 331 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 331 was vectorized.  A "ivdep" directive was specified.
   332  			//c = c1;
   333  			c.bitwiseMoveFrom(c1);
   334  			global::nops+= N;
   335  		}
   336  		break;
   337  	case pair(KComplexArray,KIntArray):
   338  		N = a.length();
   339  		if (N == b.length()) {
   340  			Tobject c1;
   341  			c1.copydimsIntArray(a);
   342  			Tint *c1p=c1.IntPtr(); Tcomplex *ap=a.ComplexPtr(); Tint *bp=b.IntPtr();
   343  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 343 was bottom loaded.
******    Loop starting at line 343 was not vectorized.  It contains a reference to a whole structure at line 343.
******    Loop starting at line 343 was bottom loaded.
******    Loop starting at line 343 was not vectorized.  It contains a reference to a whole structure at line 343.
   344  			//c = c1;
   345  			c.bitwiseMoveFrom(c1);
   346  			global::nops+= N;
   347  		} else c = OP(0,1);
   348  		break;
   349  	case pair(KComplexArray,KRealArray):
   350  		N = a.length();
   351  		if (N == b.length()) {
   352  			Tobject c1;
   353  			c1.copydimsIntArray(a);
   354  			Tint *c1p=c1.IntPtr(); Tcomplex *ap=a.ComplexPtr(); Treal *bp=b.RealPtr();
   355  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 355 was bottom loaded.
******    Loop starting at line 355 was not vectorized.  It contains a reference to a whole structure at line 355.
******    Loop starting at line 355 was bottom loaded.
******    Loop starting at line 355 was not vectorized.  It contains a reference to a whole structure at line 355.
   356  			//c = c1;
   357  			c.bitwiseMoveFrom(c1);
   358  			global::nops+= N;
   359  		} else c = OP(0,1);
   360  		break;
   361  	case pair(KComplexArray,KComplexArray):
   362  		N = a.length();
   363  		if (N == b.length()) {
   364  			Tobject c1;
   365  			c1.copydimsIntArray(b);
   366  			Tint *c1p=c1.IntPtr(); Tcomplex *bp=b.ComplexPtr(); Tcomplex *ap=a.ComplexPtr();
   367  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 367 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 367 was vectorized.  A "ivdep" directive was specified.
   368  			//c = c1;
   369  			c.bitwiseMoveFrom(c1);
   370  			global::nops+= N;
   371  		} else c = OP(0,1);
   372  		break;
   373  	case pair(KObjectArray,KObjectArray):
   374  		N = a.length();
   375  		if (N == b.length()) {
   376  			Tobject c1;
   377  			c1.copydimsIntArray(b);
   378  			Tint *c1p=c1.IntPtr();
   379  			TObjectPtr *bp=b.ObjectPtrPtr(), *ap=a.ObjectPtrPtr();
   380  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],bp[i]);
******    Loop starting at line 380 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 380 was vectorized.  A "ivdep" directive was specified.
   381  			//c = c1;
   382  			c.bitwiseMoveFrom(c1);
   383  			global::nops+= N;
   384  		} else c = OP(0,1);
   385  		break;
   386  	case pair(Kfunction,Kfunction):
   387  		c = OP(a.FunctionValue(),b.FunctionValue());
   388  		break;
   389  	case pair(KCfunction,KCfunction):
   390  		c = OP(a.CFunctionPtr(),b.CFunctionPtr());
   391  		break;
   392  	case pair(KIntrinsicFunction,KIntrinsicFunction):
   393  		c = OP(a.IntrinsicCompilerPtr(),b.IntrinsicCompilerPtr());
   394  		break;
   395  	case pair(Kvoid,Kvoid):
   396  		c = OP(0,0);
   397  		break;
   398  	default:
   399  		// The default for two arbitrary nonmatching structures is to
   400  		// return OP(0,1), of course, unless one of the args is undefined,
   401  		// which leads to error.
   402  		if (a.kind()==Kundef || b.kind()==Kundef) BinError(OPCHAR,a,b);
   403  		c = OP(0,1);
   404  		break;
   405  	}
   406  }
