----------------------------------------------------------
  Cray Standard C V>=3.0 compiler listing
  Produced by mkcclisting.c V2.0 (written by PJ 22.5.1995)
----------------------------------------------------------
     1  /*
     2   * This file is part of tela the Tensor Language.
     3   * Copyright (c) 1994-1995 Pekka Janhunen
     4   */
     5  
     6  /*
     7   * tminmaxop.C - 'template' for a binary min/max operator, included separately for Min,Max
     8   */
     9  
    10  void OPFNAME(Tobject& c, const Tobject& a, const Tobject& b) {
    11  	int i,N;
    12  	Tint I; Treal X;
    13  	switch (pair(a.kind(),b.kind())) {
    14  	case pair(Kint,Kint):
    15  		c = OP(a.IntValue(),b.IntValue());
    16  		global::nops++;
    17  		break;
    18  	case pair(Kint,Kreal):
    19  		c = OP(Treal(a.IntValue()),b.RealValue());
    20  		global::nops++;
    21  		break;
    22  	case pair(Kint,KIntArray):
    23  		{
    24  			I = a.IntValue();
    25  			N = b.length();
    26  			c.copydimsIntArray(b);
    27  			Tint *cp=c.IntPtr(), *bp=b.IntPtr();
    28  			for (i=0; i<N; i++) cp[i] = OP(I,bp[i]);
******    Loop starting at line 28 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 28 was vectorized.  A "ivdep" directive was specified.
    29  			global::nops+= N;
    30  		}
    31  		break;
    32  	case pair(Kint,KRealArray):
    33  		{
    34  			N = b.length();
    35  			X = Treal(a.IntValue());
    36  			c.copydimsRealArray(b);
    37  			Treal *cp=c.RealPtr(); Treal *bp=b.RealPtr();
    38  			for (i=0; i<N; i++) cp[i] = OP(X,bp[i]);
******    Loop starting at line 38 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 38 was vectorized.  A "ivdep" directive was specified.
    39  			global::nops+= N;
    40  		}
    41  		break;
    42  	case pair(Kreal,Kint):
    43  		c = OP(a.RealValue(),Treal(b.IntValue()));
    44  		global::nops++;
    45  		break;
    46  	case pair(Kreal,Kreal):
    47  		c = OP(a.RealValue(),b.RealValue());
    48  		global::nops++;
    49  		break;
    50  	case pair(Kreal,KIntArray):
    51  		{
    52  			Tobject c1;
    53  			X = a.RealValue();
    54  			N = b.length();
    55  			c1.copydimsRealArray(b);	// make c1 a real array of the same dims as b
    56  			Treal *c1p=c1.RealPtr(); Tint *bp=b.IntPtr();
    57  			for (i=0; i<N; i++) c1p[i] = OP(X,Treal(bp[i]));
******    Loop starting at line 57 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 57 was vectorized.  A "ivdep" directive was specified.
    58  			//c = c1;
    59  			c.bitwiseMoveFrom(c1);
    60  			global::nops+= N;
    61  		}
    62  		break;
    63  	case pair(Kreal,KRealArray):
    64  		{
    65  			N = b.length();
    66  			X = a.RealValue();
    67  			c.copydimsRealArray(b);
    68  			Treal *cp=c.RealPtr(); Treal *bp=b.RealPtr();
    69  			for (i=0; i<N; i++) cp[i] = OP(X,bp[i]);
******    Loop starting at line 69 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 69 was vectorized.  A "ivdep" directive was specified.
    70  			global::nops+= N;
    71  		}
    72  		break;
    73  	case pair(KIntArray,Kint):
    74  		{
    75  			N = a.length();
    76  			I = b.IntValue();
    77  			c.copydimsIntArray(a);
    78  			Tint *cp=c.IntPtr(), *ap=a.IntPtr();
    79  			for (i=0; i<N; i++) cp[i] = OP(ap[i],I);
******    Loop starting at line 79 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 79 was vectorized.  A "ivdep" directive was specified.
    80  			global::nops+= N;
    81  		}
    82  		break;
    83  	case pair(KIntArray,Kreal):
    84  		{
    85  			Tobject c1;
    86  			N = a.length();
    87  			X = b.RealValue();
    88  			c1.copydimsRealArray(a);
    89  			Treal *c1p=c1.RealPtr(); Tint *ap=a.IntPtr();
    90  			for (i=0; i<N; i++) c1p[i] = OP(Treal(ap[i]),X);
******    Loop starting at line 90 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 90 was vectorized.  A "ivdep" directive was specified.
    91  			//c = c1;
    92  			c.bitwiseMoveFrom(c1);
    93  			global::nops+= N;
    94  		}
    95  		break;
    96  	case pair(KIntArray,KIntArray):
    97  		{
    98  			N = a.length();
    99  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   100  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   101  			c.copydimsIntArray(a);
   102  			Tint *cp=c.IntPtr(), *ap=a.IntPtr(), *bp=b.IntPtr();
   103  			for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 103 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 103 was vectorized.  A "ivdep" directive was specified.
   104  			global::nops+= N;
   105  		}
   106  		break;
   107  	case pair(KIntArray,KRealArray):
   108  		{
   109  			Tobject c1;
   110  			c1.copydimsRealArray(b);
   111  			N = a.length();
   112  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   113  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   114  			Treal *c1p=c1.RealPtr(); Tint *ap=a.IntPtr(); Treal *bp=b.RealPtr();
   115  			for (i=0; i<N; i++) c1p[i] = OP(Treal(ap[i]),bp[i]);
******    Loop starting at line 115 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 115 was vectorized.  A "ivdep" directive was specified.
   116  			//c = c1;
   117  			c.bitwiseMoveFrom(c1);
   118  			global::nops+= N;
   119  		}
   120  		break;
   121  	case pair(KRealArray,Kint):
   122  		{
   123  			N = a.length();
   124  			X = Treal(b.IntValue());
   125  			c.copydimsRealArray(a);
   126  			Treal *cp=c.RealPtr(); Treal *ap=a.RealPtr();
   127  			for (i=0; i<N; i++) cp[i] = OP(ap[i],X);
******    Loop starting at line 127 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 127 was vectorized.  A "ivdep" directive was specified.
   128  			global::nops+= N;
   129  		}
   130  		break;
   131  	case pair(KRealArray,Kreal):
   132  		{
   133  			N = a.length();
   134  			X = b.RealValue();
   135  			c.copydimsRealArray(a);
   136  			Treal *cp=c.RealPtr(); Treal *ap=a.RealPtr();
   137  			for (i=0; i<N; i++) cp[i] = OP(ap[i],X);
******    Loop starting at line 137 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 137 was vectorized.  A "ivdep" directive was specified.
   138  			global::nops+= N;
   139  		}
   140  		break;
   141  	case pair(KRealArray,KIntArray):
   142  		{
   143  			Tobject c1;
   144  			c1.copydimsRealArray(a);
   145  			N = a.length();
   146  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   147  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   148  			Treal *c1p=c1.RealPtr(); Tint *bp=b.IntPtr(); Treal *ap=a.RealPtr();
   149  			for (i=0; i<N; i++) c1p[i] = OP(ap[i],Treal(bp[i]));
******    Loop starting at line 149 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 149 was vectorized.  A "ivdep" directive was specified.
   150  			//c = c1;
   151  			c.bitwiseMoveFrom(c1);
   152  			global::nops+= N;
   153  		}
   154  		break;
   155  	case pair(KRealArray,KRealArray):
   156  		{
   157  			N = a.length();
   158  			//if (N != b.length()) LengthError(OPCHAR,a,b);
   159  			if (!a.iscompatible(b)) LengthError(OPCHAR,a,b);
   160  			c.copydimsRealArray(a);
   161  			Treal *cp=c.RealPtr(); Treal *ap=a.RealPtr(), *bp=b.RealPtr();
   162  			for (i=0; i<N; i++) cp[i] = OP(ap[i],bp[i]);
******    Loop starting at line 162 was vectorized.  A "ivdep" directive was specified.
******    Loop starting at line 162 was vectorized.  A "ivdep" directive was specified.
   163  			global::nops+= N;
   164  		}
   165  		break;
   166  	default:
   167  		BinError(OPCHAR,a,b);
   168  		break;
   169  	}
   170  }
